Package: Iso
Version: 0.0-21
Date: 2023-10-02
Title: Functions to Perform Isotonic Regression
Author: Rolf Turner <rolfturner@posteo.net>
Maintainer: Rolf Turner <rolfturner@posteo.net>
Depends: R (>= 1.7.0)
Description: Linear order and unimodal order (univariate)
	     isotonic regression; bivariate isotonic regression
	     with linear order on both variables.
LazyData: true
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2023-10-01 20:50:05 UTC; rolf
Repository: CRAN
Date/Publication: 2023-10-02 06:50:13 UTC
Built: R 4.3.3; aarch64-apple-darwin20; 2025-01-24 03:26:10 UTC; unix
Archs: Iso.so.dSYM

Package: Iso
Version: 0.0-21
Date: 2023-10-02
Title: Functions to Perform Isotonic Regression
Author: Rolf Turner <rolfturner@posteo.net>
Maintainer: Rolf Turner <rolfturner@posteo.net>
Depends: R (>= 1.7.0)
Description: Linear order and unimodal order (univariate)
	     isotonic regression; bivariate isotonic regression
	     with linear order on both variables.
LazyData: true
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2023-10-01 20:50:05 UTC; rolf
Repository: CRAN
Date/Publication: 2023-10-02 06:50:13 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 16:06:30 UTC; unix
Archs: Iso.so.dSYM

ISO-639_3

The README is used to introduce the module and provide instructions on
how to install the module, any machine dependencies it may have (for
example C compilers and installed libraries) and any other information
that should be provided before the module is installed.

A README file is required for CPAN modules since CPAN extracts the README
file from a module distribution so that people browsing the archive
can use it to get an idea of the module's uses. It is usually a good idea
to provide version information here so that people can decide whether
fixes for the module are worth downloading.


INSTALLATION

To install this module, run the following commands:

	perl Makefile.PL
	make
	make test
	make install

SUPPORT AND DOCUMENTATION

After installing, you can find documentation for this module with the
perldoc command.

    perldoc ISO::639_3

You can also look for information at:

    RT, CPAN's request tracker (report bugs here)
        https://rt.cpan.org/NoAuth/Bugs.html?Dist=ISO-639_3

    AnnoCPAN, Annotated CPAN documentation
        http://annocpan.org/dist/ISO-639_3

    CPAN Ratings
        https://cpanratings.perl.org/d/ISO-639_3

    Search CPAN
        https://metacpan.org/release/ISO-639_3


LICENSE AND COPYRIGHT

This software is Copyright (c) 2020 by Joerg Tiedemann.

This is free software, licensed under:

  The MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

iso-8601
===========

Correctly parse a valid ISO 8601 datetime string.

At this stage, only datetime (or non-truncated date) formats are permitted.

Week number formats are not permitted in this version.

You can have an object in any of the following formats:

	* YYYY-MM-DD
	* YYYYMMDD
	* YYYY-MM-DDThh
	* YYYYMMDDThh
	* YYYY-MM-DDThh:mm
	* YYYYMMDDThhmm
	* YYYY-MM-DDThh:mm:ss
	* YYYYMMDDThhmmss

Additionally, to support some legacy systems, in all cases the T can be
replaced by a space. Essentially, this just combines the two representations,
which is not strictly according to the specification, but is commonly used.

Also supported is using an hour of 24 to mean midnight at the end of the
day: this is converted to the python object of the next day's 00:00:00.
Using a non-zero minute/second/fraction will raise a ValueError.

A fractional value may be appended to the last component of a time part.
Appending it elsewhere will raise a ValueError.

Finally, only naive datetime objects are supported at this time. Timezones
may not be included in the format string.

Duration time formats of the following forms are also supported:

  * P1W2DT3H4M5S

Note that support for Year and Month data is not supported, as this does not
make sense with python's timedelta object.

You may, as per ISO8601, drop fields that have no value.

Future (in no particular order):

	* Support timezones
	* Support durations fully
	* Support time intervals
	* Support repeating intervals
	* Support week-dates
	* Support truncated dates
	* Support time only objects (including truncated?)

The following references were used to determine supported formats:

	* http://en.wikipedia.org/wiki/ISO_8601
	* http://dotat.at/tmp/ISO_8601-2004_E.pdf

Changelog:
    
    0.2.4 - Workaround for errors when using freezegun.
    
    0.2.3 - Added parse_date to module exports.
    
    0.2.2 - Add methods for forcing return of a date (or time): parse_date()
    
    0.2.1 - Initial support for duration data (excluding year/month).
          - Initial support for formatting objects.
    
    0.1.6 - Allow for a date or datetime object to be passed to parse.
	
    0.1.5 - Added support for fractional times.
    
    0.1.1 - Helps if I spell my domain name right.
    
    0.1   - Initial release.

# NAME

ISO::639\_1 - ISO 639-1 Language informations

# SYNOPSIS

    use ISO::639_1;
    print get_iso639_1('zu')->{'639-1'};    # zu
    print get_iso639_1('zu')->{'639-2'};    # zul
    print get_iso639_1('zu')->{family};     # Niger–Congo
    print get_iso639_1('zu')->{name};       # Zulu
    print get_iso639_1('zu')->{nativeName}; # isiZulu
    print get_iso639_1('zu')->{wikiUrl};    # https://en.wikipedia.org/wiki/Zulu_language

    print get_iso639_1('fr')->{nativeName};    # Français
    print get_iso639_1('fr-BE')->{nativeName}; # Français (BE)
    print get_iso639_1('ur')->{nativeName};    # اردو

    print get_iso639_1_from_639_2('fra')->{nativeName};     # Français
    print get_iso639_1_from_name('french')->{nativeName};   # Français
    print get_iso639_1_from_native_name('français')->{name} # French

# DESCRIPTION

ISO::639\_1 provides informations about a language from its ISO639-1 code.

It differs from [ISO::639](https://metacpan.org/pod/ISO::639) which is about ISO639-2.

The informations are extracted from [https://github.com/haliaeetus/iso-639/](https://github.com/haliaeetus/iso-639/) (MIT license).

# METHODS

ISO::639\_1 exports the following methods:

## get\_iso639\_1

    Usage    : get_iso639_1('zu')
    Returns  : a hashref providing the informations described below. May return undef if no language is found.
              {
                  "639-1"      => "zu",          # ISO 639-1 code
                  "639-2"      => "zul",         # ISO 639-2 code
                  "family"     => "Niger–Congo", # family of language
                  "name"       => "Zulu",        # english name of the language
                  "nativeName" => "isiZulu",     # native name of the language
                  "wikiUrl"    => "https://en.wikipedia.org/wiki/Zulu_language" # wikipedia URL about the language
              }
    Argument : an ISO639-1 code with or without localization code.
               If a localization code is provided, (think "fr-BE", or "fr_BE"), the localization is
               appended to the name and nativeName informations (like "Français (BE)").
               Localization must be separated from the language code by "-" or "_".

## get\_iso639\_1\_from\_639\_2

    Usage    : get_iso639_1_from_639_2('fra')
    Returns  : a hashref providing the informations described below. May return undef if no language is found.
              {
                  "639-1"      => "zu",          # ISO 639-1 code
                  "639-2"      => "zul",         # ISO 639-2 code
                  "family"     => "Niger–Congo", # family of language
                  "name"       => "Zulu",        # english name of the language
                  "nativeName" => "isiZulu",     # native name of the language
                  "wikiUrl"    => "https://en.wikipedia.org/wiki/Zulu_language" # wikipedia URL about the language
              }
    Argument : an ISO639-2 code (case insensitive)

## get\_iso639\_1\_from\_name

    Usage    : get_iso639_1_from_name('French')
    Returns  : a hashref providing the informations described below. May return undef if no language is found.
              {
                  "639-1"      => "zu",          # ISO 639-1 code
                  "639-2"      => "zul",         # ISO 639-2 code
                  "family"     => "Niger–Congo", # family of language
                  "name"       => "Zulu",        # english name of the language
                  "nativeName" => "isiZulu",     # native name of the language
                  "wikiUrl"    => "https://en.wikipedia.org/wiki/Zulu_language" # wikipedia URL about the language
              }
    Argument : the english name of a language (case insensitive)

## get\_iso639\_1\_from\_native\_name

    Usage    : get_iso639_1_from_native_name('Français')
    Returns  : a hashref providing the informations described below. May return undef if no language is found.
              {
                  "639-1"      => "zu",          # ISO 639-1 code
                  "639-2"      => "zul",         # ISO 639-2 code
                  "family"     => "Niger–Congo", # family of language
                  "name"       => "Zulu",        # english name of the language
                  "nativeName" => "isiZulu",     # native name of the language
                  "wikiUrl"    => "https://en.wikipedia.org/wiki/Zulu_language" # wikipedia URL about the language
              }
    Argument : the native name of a language (case insensitive)

# INSTALL

After getting the tarball on [https://metacpan.org/release/ISO::639\_1](https://metacpan.org/release/ISO::639_1), untar it, go to the directory and:

    perl Build.PL
    ./Build
    ./Build test
    ./Build install

# BUGS and SUPPORT

You can find documentation for this module with the perldoc command.

    perldoc ISO::639_1

Bugs and feature requests will be tracked on:

    https://framagit.org/fiat-tux/perl-modules/iso-639_1/issues

The latest source code can be browsed and fetched at:

    https://framagit.org/fiat-tux/perl-modules/iso-639_1
    git clone https://framagit.org/fiat-tux/perl-modules/iso-639_1.git

Source code mirror:

    https://github.com/ldidry/iso-639_1

You can also look for information at:

    AnnoCPAN: Annotated CPAN documentation

    http://annocpan.org/dist/ISO::639_1
    CPAN Ratings

    http://cpanratings.perl.org/d/ISO::639_1
    Search CPAN

    http://search.cpan.org/dist/ISO::639_1

# LICENSE

Copyright (C) Luc Didry.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

The full text of the license can be found in the
LICENSE file included with this module.

# SEE ALSO

[ISO::639](https://metacpan.org/pod/ISO::639)

# AUTHOR

Luc Didry <luc@didry.org>
[https://fiat-tux.fr](https://fiat-tux.fr)

subroutine ufit(y,w,imode,ymdf,wmdf,mse,y1,w1,y2,w2,ind,kt,n)
implicit double precision(a-h,o-z)
double precision imode, mse, imax
dimension y(n), w(n), ymdf(n), wmdf(n),y1(n), w1(n), y2(n), w2(n), ind(n), kt(n)

# Nude virgin of ufit --- 18/8/95.
# The changes are based upon Pete's observation that when we are
# seeking the OPTIMIUM mode (in terms of SSE) we need only search
# over the ``half-points'' --- 1.5, 2.5, ..., n-0.5.  If the optimum
# is at k, then the half-points k-0.5 and k+05 give SSEs that are
# at least as small as and hence are equal to the SSE at k.  This is
# because if a function is increasing on 1,...,k and decreasing on
# k,...n, then it is increasing on 1,...,(k-1)) and decreasing on
# k,...,n !!!  (And likewise for 1,...,k and (k+1),...n.)   Thus if
# there is an optimum at k then there are optima at k-0.5 and k+0.5.
# Of course if k=1 then k-0.5 is not considered and likewise if k=n
# then k+0.5 is not considered.
#
# Note also that if there is an optimum at the half-point k-0.5, then
# there is also a whole-point optimum either at k-1 or k.
#
# Explanation revised (corrected) 31/05/2015.
#
# Note that in this subroutine there is no "x" argument.  The
# *indices* of a conceptual "x" are dealt with. (22/07/2023)

if(imode < 0) {
	m      =  n-1
	tau    =  1.5d0
	imax   = -1.d0
	ssemin =  1.d200

	do i = 1,m {
		do j = 1,n {
			ymdf(j) = y(j)
			wmdf(j) = w(j)
		}
		call unimode(ymdf,wmdf,y1,w1,y2,w2,ind,kt,tau,n)
		sse = 0.d0
		do j = 1,n {
			sse = sse + (ymdf(j)-y(j))**2
		}
		if(sse < ssemin) {
			ssemin = sse
			imax   = tau
		}
		tau = tau+1.d0
	}
	k1 = int(imax-0.5d0)
	k2 = int(imax+0.5d0)
}
else imax = imode
do j = 1,n {
   ymdf(j) = y(j)
   wmdf(j) = w(j)
}
#call dblepr("imax:",-1,imax,1)
#call dblepr("y:",-1,y,6)
#call dblepr("w:",-1,w,6)
#call dblepr("ymdf:",-1,ymdf,6)
#call dblepr("wmdf:",-1,wmdf,6)

call unimode(ymdf,wmdf,y1,w1,y2,w2,ind,kt,imax,n)
#call labpepr("Got past first call to unimode.",-1)

if(imode < 0) {
	mse = ssemin/dble(n)
	if(ymdf(k1)>=ymdf(k2)) imode=dble(k1)
	else imode=dble(k2)
}
else {
	sse = 0.d0
	do j = 1,n {
		sse = sse + (ymdf(j)-y(j))**2
	}
	mse = sse/dble(n)
}
return
end

subroutine unimode(y,w,y1,w1,y2,w2,ind,kt,tau,n)
implicit double precision(a-h,o-z)
dimension y(n), w(n), y1(n), w1(n), y2(n), w2(n), ind(n), kt(n)

# Handle the linear ordering cases:
if(tau >= dble(n)) {
	call pava(y,w,kt,n)
	return
}

if(tau <= 1.d0) {
	do i = 1,n {
		j = n+1-i
		y2(i) = y(j)
                w2(i) = w(j)
        }
	call pava(y2,w2,kt,n)
	do i = 1,n {
		j = n+1-i
		y(i) = y2(j)
		w(i) = w2(j)
	}
	return
}

k1 = 0
k2 = 0
do i = 1,n {
	if(i < tau) {
		y1(i) = y(i)
		w1(i) = w(i)
		k1 = k1+1
	}
	if(i > tau) {
		j = n+1-i
		y2(j) = y(i)
		w2(j) = w(i)
		k2 = k2+1
	}
}

if(k1==0) {
    call rexit("The index of the mode is 0.\n")
}
if(k2==0) {
    call rexit("The index of the mode is one more than the number of indices.\n")
}

if(k1+k2 == n) {
	call pava(y1,w1,kt,k1)
	do i = 1,k1 {
		y(i) = y1(i)
		w(i) = w1(i)
	}
	call pava(y2,w2,kt,k2)
	do i = 1,k2 {
		j = n+1-i
		y(j) = y2(i)
		w(j) = w2(i)
	}
	return
}

if(k1+k2 == n-1) {
	yk = y(k1+1)
	call pava(y1,w1,kt,k1)
	call pava(y2,w2,kt,k2)
	i1 = 1
	i2 = 1
	i  = 1
	repeat{
		if(i1 <= k1) t1 = y1(i1)
		else t1 = y2(k2)+1.d10
		if(i2 <= k2) t2 = y2(i2)
		else t2 = y1(k1)+1.d10

		if(t1 < t2) {
			y(i) = y1(i1)
			ind(i) = i1
			i1 = i1+1
		}
		else {
			y(i) = y2(i2)
			ind(i) = n-i2+1
			i2 = i2+1
		}
		i = i + 1
		if(i == n) break
	}
	y(n) = yk
	ind(n) = k1+1
	do i = 1,n {
		w1(ind(i)) = w(i)
	}
	do i = 1,n {
		w(i) = w1(i)
	}
	call pava(y,w,kt,n)
	do i = 1,n {
		y1(ind(i)) = y(i)
		w1(ind(i)) = w(i)
	}
	do i = 1,n {
		y(i) = y1(i)
		w(i) = w1(i)
	}
} else {
    call rexit("The total length of the monotone segments is neither n nor n-1.")
}
return
end

subroutine pava(y,w,kt,n)
implicit double precision(a-h,o-z)
logical same
dimension y(n), w(n), kt(n)

# Note: `kt' <--> `keep track' (of the level sets).

do i = 1,n {
	kt(i) = i
}

if(n==1) return

repeat{
	same = .true.
	do i = 2,n {
		if(y(i-1) > y(i)) {
			k1 = kt(i)
			k2 = kt(i-1)
			do j = 1,n {
				if(kt(j)==k1) kt(j) = k2
			}
			wnew = w(i-1) + w(i)
			ynew = (w(i-1)*y(i-1)+w(i)*y(i))/wnew
			do j = 1,n {
				if(kt(j)==k2) {
					y(j) = ynew
					w(j) = wnew
				}
			}
			same = .false.
		}
	}
	if(same) break
}

return
end

C Output from Public domain Ratfor, version 1.03
      subroutine unimode(y,w,y1,w1,y2,w2,ind,kt,tau,n)
      implicit double precision(a-h,o-z)
      dimension y(n), w(n), y1(n), w1(n), y2(n), w2(n), ind(n), kt(n)
      if(tau .ge. dble(n))then
      call pava(y,w,kt,n)
      return
      endif
      if(tau .le. 1.d0)then
      do23004 i = 1,n 
      j = n+1-i
      y2(i) = y(j)
      w2(i) = w(j)
23004 continue
23005 continue
      call pava(y2,w2,kt,n)
      do23006 i = 1,n 
      j = n+1-i
      y(i) = y2(j)
      w(i) = w2(j)
23006 continue
23007 continue
      return
      endif
      k1 = 0
      k2 = 0
      do23008 i = 1,n 
      if(i .lt. tau)then
      y1(i) = y(i)
      w1(i) = w(i)
      k1 = k1+1
      endif
      if(i .gt. tau)then
      j = n+1-i
      y2(j) = y(i)
      w2(j) = w(i)
      k2 = k2+1
      endif
23008 continue
23009 continue
      if(k1.eq.0)then
      call rexit("The index of the mode is 0.\n")
      endif
      if(k2.eq.0)then
      call rexit("The index of the mode is one more than the number of i
     *ndices.\n")
      endif
      if(k1+k2 .eq. n)then
      call pava(y1,w1,kt,k1)
      do23020 i = 1,k1 
      y(i) = y1(i)
      w(i) = w1(i)
23020 continue
23021 continue
      call pava(y2,w2,kt,k2)
      do23022 i = 1,k2 
      j = n+1-i
      y(j) = y2(i)
      w(j) = w2(i)
23022 continue
23023 continue
      return
      endif
      if(k1+k2 .eq. n-1)then
      yk = y(k1+1)
      call pava(y1,w1,kt,k1)
      call pava(y2,w2,kt,k2)
      i1 = 1
      i2 = 1
      i = 1
23026 continue
      if(i1 .le. k1)then
      t1 = y1(i1)
      else
      t1 = y2(k2)+1.d10
      endif
      if(i2 .le. k2)then
      t2 = y2(i2)
      else
      t2 = y1(k1)+1.d10
      endif
      if(t1 .lt. t2)then
      y(i) = y1(i1)
      ind(i) = i1
      i1 = i1+1
      else
      y(i) = y2(i2)
      ind(i) = n-i2+1
      i2 = i2+1
      endif
      i = i + 1
      if(i .eq. n)then
      goto 23028
      endif
23027 goto 23026
23028 continue
      y(n) = yk
      ind(n) = k1+1
      do23037 i = 1,n 
      w1(ind(i)) = w(i)
23037 continue
23038 continue
      do23039 i = 1,n 
      w(i) = w1(i)
23039 continue
23040 continue
      call pava(y,w,kt,n)
      do23041 i = 1,n 
      y1(ind(i)) = y(i)
      w1(ind(i)) = w(i)
23041 continue
23042 continue
      do23043 i = 1,n 
      y(i) = y1(i)
      w(i) = w1(i)
23043 continue
23044 continue
      else
      call rexit("The total length of the monotone segments is neither n
     * nor n-1.")
      endif
      return
      end

C Output from Public domain Ratfor, version 1.03
      subroutine pava(y,w,kt,n)
      implicit double precision(a-h,o-z)
      logical same
      dimension y(n), w(n), kt(n)
      do23000 i = 1,n 
      kt(i) = i
23000 continue
23001 continue
      if(n.eq.1)then
      return
      endif
23004 continue
      same = .true.
      do23007 i = 2,n 
      if(y(i-1) .gt. y(i))then
      k1 = kt(i)
      k2 = kt(i-1)
      do23011 j = 1,n 
      if(kt(j).eq.k1)then
      kt(j) = k2
      endif
23011 continue
23012 continue
      wnew = w(i-1) + w(i)
      ynew = (w(i-1)*y(i-1)+w(i)*y(i))/wnew
      do23015 j = 1,n 
      if(kt(j).eq.k2)then
      y(j) = ynew
      w(j) = wnew
      endif
23015 continue
23016 continue
      same = .false.
      endif
23007 continue
23008 continue
      if(same)then
      goto 23006
      endif
23005 goto 23004
23006 continue
      return
      end

      SUBROUTINE SMOOTH(NROW, NCOL, NDIM, X, W, A, B, NCYCLE, ICYCLE, G,
     *   EPS1, EPS2, IFAULT, FX, PW, W1, WT, NW)
C
C     ALGORITHM AS 206  APPL. STATIST. (1984) VOL.33, NO.3
C
C     Subroutine to order a two-dimensional array using an algorithm of
C     Dykstra & Robertson (1982).   The ordering is done so that the
C     regression function is increasing in each independent variable.
C
C     Incorporates corrections from Applied Statistics vol.35(3), 
C     vol.36(1) and vol.40(1).
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(NROW,NCOL), W(NROW,NCOL), A(NROW,NCOL,4)
      DIMENSION B(NDIM,5), G(NROW,NCOL)
      DIMENSION FX(NDIM), PW(NDIM), W1(NDIM), WT(NDIM)
      INTEGER NW(NDIM)
      DATA ZERO/0.0d0/, DELTA/0.00001d0/, FRACT/0.5d0/
C
      IFAULT = 0
C Rprintf("epsilon =%f12.6",EPS)
C Rprintf("zero =%f12.6",ZERO)
C Rprintf("delta =%f12.6",DELTA)
C Rprintf("fract =%f12.6",FRACT)
C
C     Check that there are at least 2 rows and columns
C
      IF (NROW .LT. 2 .OR. NCOL .LT. 2) GO TO 120
C
C     Check that weights are positive or zero
C
      WSUM = ZERO
      WXSUM = ZERO
      WMIN = 1.0d+08
      DO 3 I = 1, NROW
        DO 4 J = 1, NCOL
          WW = W(I,J)
          IF (WW .LT. ZERO) GO TO 110
          IF (WW .LT. DELTA) GO TO 3
          WSUM = WSUM + WW
          WXSUM = WXSUM + WW * X(I,J)
          IF (WW .LT. WMIN) WMIN = WW
    4 CONTINUE
    3 CONTINUE
      IF (WSUM .LT. DELTA) GO TO 130
      WMEAN = WXSUM / WSUM
C
      DO 5 I = 1, NROW
      DO 6 J = 1, NCOL
        WW = W(I,J)
        A(I,J,3) = WW
        A(I,J,4) = X(I,J)
        IF (WW .GE. DELTA) GO TO 6
        A(I,J,3) = FRACT * WMIN
        A(I,J,4) = WMEAN
        ICT = ICT + 1
        IFAULT = 4
    6 CONTINUE
    5 CONTINUE
C
C     Initialize R and C to zero, and set up workspace
C
      IFLAG = 0
      DELR = ZERO
      DELC = ZERO
      ITIC = 0
    8 ITIC = ITIC + 1
      DO 10 I = 1, NROW
      DO 11 J = 1, NCOL
        G(I,J) = A(I,J,4)
        A(I,J,2) = ZERO
        A(I,J,1) = ZERO
   11 CONTINUE
   10 CONTINUE
C
C     Initialize counter for number of cycles
C
      ICOUNT = 0
      IF (IFLAG .EQ. 1) GO TO 55
      IF (ITIC .EQ. 3 .AND. DELC .GT. DELR) GO TO 55
C
C     Smooth over rows
C
   25 JCOUNT = 0
      DO 50 I = 1, NROW
      DO 30 J = 1, NCOL
        B(J,1) = G(I,J) - A(I,J,1)
        B(J,2) = A(I,J,3)
   30   CONTINUE
C
      CALL PAV(NCOL, NDIM, EPS2, B, 1, B(1,2), B(1,3), FX,
     * PW, W1, WT, NW)
C
      KCOUNT = 0
      DO 40 J = 1, NCOL
        ORD = B(J,3)
        A(I,J,1) = ORD - B(J,1)
        IF (ABS(ORD - G(I,J)) .LT. EPS1) KCOUNT = KCOUNT + 1
        G(I,J) = ORD
   40   CONTINUE
C
C     Determine if there is no change in the Ith row from the previous
C     iteration
C
      IF (KCOUNT .EQ. NCOL) JCOUNT = JCOUNT + 1
   50 CONTINUE
C
      ICOUNT = ICOUNT + 1
      IF (ICOUNT .EQ. 2 .AND. IFLAG .EQ. 1)
     *    CALL DIST(A(1,1,1), NROW, NCOL, DELR, IFLAG)
      IF (ICOUNT .EQ. 2 .AND. IFLAG .EQ. 2 .AND. ITIC .EQ. 2) GO TO 8
      IF (ICOUNT .EQ. 1) GO TO 55
      IF (NCYCLE .EQ. ICOUNT) GO TO 100
C
C     Determine if there has been no change in all rows from the
C     previous iteration
C
      IF (JCOUNT .EQ. NROW) GO TO 90
C
C     Smooth over columns
C
   55 LCOUNT = 0
      DO 80 J = 1, NCOL
      DO 60 I = 1, NROW
        A(I,J,2) = G(I,J) - A(I,J,2)
   60  CONTINUE
C
      CALL PAV(NROW, NDIM, EPS2, A(1,J,2), 1, A(1,J,3), B(1,3), FX,
     * PW, W1, WT, NW)
C
      MCOUNT = 0
      DO 70 I = 1, NROW
        ORD = B(I,3)
        A(I,J,2) = ORD - A(I,J,2)
        IF (ABS(ORD - G(I,J)) .LT. EPS1) MCOUNT = MCOUNT + 1
        G(I,J) = ORD
   70   CONTINUE
C
C     Determine if there is no change in the Jth column from the
C     previous iteration
C
      IF (MCOUNT .EQ. NROW) LCOUNT = LCOUNT + 1
   80 CONTINUE
C
      ICOUNT = ICOUNT + 1
      IF (ICOUNT .EQ. 2 .AND. IFLAG .EQ. 0)
     *    CALL DIST(A(1,1,2), NROW, NCOL, DELC, IFLAG)
      IF (ICOUNT .EQ. 2 .AND. IFLAG .EQ. 1) GO TO 8
      IF (ICOUNT .EQ. 1) GO TO 25
C
C     Determine if there is has been no change in any column from the
C     previous iteration
C
      IF (LCOUNT .EQ. NCOL) GO TO 90
C
C     Check if number of cycles has been reached
C
      IF (NCYCLE .EQ. ICOUNT) GO TO 100
      GO TO 25
   90 ICYCLE = ICOUNT
      RETURN
C
  100 ICYCLE = ICOUNT
      IFAULT = IFAULT + 1
      RETURN
  110 IFAULT = 2
      RETURN
  120 IFAULT = 3
      RETURN
  130 IFAULT = 6
      RETURN
      END


      SUBROUTINE PAV(K, NDIM, EPS2, X, IORDER, W, FINALX,
     *FX, PW, W1, WT, NW)
C
C     ALGORITHM AS 206.1  APPL. STATIST. (1984) VOL.33, NO.3
C
C     Apply pool adjacent violators theorem
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER NW(NDIM)
      dimension X(NDIM), W(NDIM), FINALX(NDIM), FX(NDIM), PW(NDIM)
      dimension W1(NDIM), WT(NDIM)
C
C     DATA EPS/1.0d-06/
C
C     Set up workspace
C
      NWC = K
      DO 10 I = 1, K
      NW(I) = 1
      FX(I) = X(I)
      IF (IORDER .EQ. 0) FX(I) = -FX(I)
      WT(I) = W(I)
      PW(I) = WT(I) * FX(I)
      W1(I) = W(I)
   10 CONTINUE
      IBEL = K - 1
   20 I = 0
   30 I = I + 1
   35 IF (I .GT. IBEL) GO TO 50
      I1 = I + 1
C
C     Determine if pooling is required
C
      IF (FX(I) - FX(I1) .LE. EPS2) GO TO 30
C
C     Pool the adjacent values
C
      PW(I) = PW(I) + PW(I1)
      W1(I) = W1(I) + W1(I1)
      FX(I) = PW(I) / W1(I)
      NW(I) = NW(I) + NW(I1)
      NWC = NWC - 1
      IF (I1 .GT. IBEL) GO TO 45
      DO 40 J = I1, IBEL
      J1 = J + 1
      PW(J) = PW(J1)
      W1(J) = W1(J1)
      FX(J) = FX(J1)
      NW(J) = NW(J1)
   40 CONTINUE
   45 IBEL = IBEL - 1
      GO TO 35
   50 ICOUNT = 0
      IF (IBEL .LE. 0) GO TO 70
C
C     Determine if all values are ordered
C
      DO 60 L = 1, IBEL
      IF (FX(L) - FX(L+1) .LE. EPS2) ICOUNT = ICOUNT + 1
   60 CONTINUE
      IF (ICOUNT .NE. IBEL) GO TO 20
C
C     Recover final ordered values
C
   70 J = 1
      JL = 1
      JU = NW(1)
   80 DO 90 L = JL,JU
      FINALX(L) = FX(J)
   90 CONTINUE
      J = J + 1
      IF (J .GT. NWC) GO TO 100
      JL = JU + 1
      JU = JU + NW(J)
      GO TO 80
  100 IF (IORDER .EQ. 1) RETURN
      DO 110 I = 1, K
      FINALX(I) = -FINALX(I)
  110 CONTINUE
      RETURN
      END


      SUBROUTINE DIST(A1, NROW, NCOL, DEL, IFLAG)
C
C     ALGORITHM AS 206.2  APPL. STATIST. (1984) VOL.33, NO.3
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      dimension A1(NROW,NCOL)
C
      DATA ZERO/0.0d0/
C
      DEL = ZERO
      DO 20 I = 1, NROW
      DO 30 J = 1, NCOL
        DEL = DEL + A1(I,J) * A1(I,J)
   30 CONTINUE
   20 CONTINUE
      IFLAG = IFLAG + 1
      RETURN
      END

pava.sa <- function(y,w=NULL,decreasing=FALSE,long.out=FALSE,stepfun=FALSE)
{
#
# Function 'pava.sa' (stand-alone pava). To perform isotonic
# regression for a simple (increasing) linear ordering using the ``pool
# adjacent violators algorithm''.  This version is programmed in raw
# R; i.e.  it does not invoke dynamically loaded fortran.  If
# long.out is TRUE then the result returned consists of a list
# containing the fitted values, the final weights, and a set of
# indices `tr', made up of the smallest index in each level set, which
# thus keeps track of the level sets.  If in addition stepfun is TRUE,
# then the step function represention of the isotonic regression is
# added to the forgoing list. If stepfun is TRUE and long.out is FALSE
# then only the stepfunction representation is returned.  If stepfun
# and long.out are both FALSE then only the fitted values are
# returned.
# 

if(decreasing) y <- rev(y)
n <- length(y)
if(is.null(w))
	w <- rep(1,n)
else if(decreasing) w <- rev(w)
r <- rep(1,n)
repeat {
	stble <- TRUE
	i <- 1
	while(i < n) {
		if(y[i] > y[i+1]) {
			stble <- FALSE
			www <- w[i] + w[i+1]
			ttt <- (w[i]*y[i] + w[i+1]*y[i+1])/www
			y[i+1] <- ttt
			w[i+1] <- www
			y <- y[-i]
			w <- w[-i]
			r[i+1] <- r[i] + r[i+1]
			r <- r[-i]
			n <- n-1
		}
		i <- i+1
	}
if(stble) break
}
y  <- rep(y,r)
if(decreasing) y <- rev(y)
if(long.out | stepfun) {
	if(decreasing) r <- rev(r)
	tr <- rep(tapply(1:length(y),rep(1:length(r),r),min),r)
}
if(long.out) {
	if(decreasing) w <- rev(w)
	w <- rep(w,r)
	lout <- list(y=y,w=w,tr=tr)
}
if(stepfun) {
	knots <- 1+which(diff(tr)!=0)
	y0    <- c(y[1],y[knots])
	h     <- stepfun(knots,y0)
}
ntype <- 1+sum(c(long.out,stepfun)*(1:2))
switch(ntype,y,lout,h,c(lout,list(h=h)))
}

biviso <- function(y, w=NULL,eps=NULL,eps2=1e-9,ncycle=50000,
                   fatal=TRUE,warn=TRUE) {
#
# Function 'biviso'.  To perform bivariate isotonic regression for simple
# (increasing) linear ordering on both variables.  Uses Applied Statistics
# Algorithm AS 206 (Isotonic regression in two independent variables;
# Gordon Bril, Richard Dykstra, Carolyn Pillers, and Tim Robertson;
# Algorithm AS 206; JRSSC (Applied Statistics), vol. 33, no. 3, pp.
# 352-357, 1984.)

# Check that ncycle makes sense:
if(ncycle!=round(ncycle) | ncycle < 2)
    stop("Argument ncycle must be an integer with value at least 2.\n")

# Check that y is of the right shape:
if(!is.numeric(y) | !is.matrix(y))
	stop("Argument \"y\" must be a numeric matrix.\n")

if(is.null(w)) w <- matrix(1,nrow=nrow(y),ncol=ncol(y)) else {
	if(!isTRUE(all.equal(dim(y),dim(w))))
		stop("Arguments \"y\" and \"w\" must have the same dimension.\n")
}

# Set epsilon:
if(is.null(eps)) eps <- sqrt(.Machine$double.eps)

nr   <- nrow(y)
nc   <- ncol(y)
nd   <- max(nr,nc)
rslt <- .Fortran(
	"smooth",
	NROW=as.integer(nr),
	NCOL=as.integer(nc),
	NDIM=as.integer(nd),
	X=as.double(y),
	W=as.double(w),
	A=double(4*nr*nc),
	B=double(5*nd),
	NCYCLE=as.integer(ncycle),
	ICYCLE=integer(1),
	G=double(nr*nc),
	EPS1=as.double(eps),
	EPS2=as.double(eps2),
	IFAULT=integer(1),
        FX=double(nd),
        PW=double(nd),
        W1=double(nd),
        WT=double(nd),
        NW=integer(nd),
	PACKAGE="Iso"
)
if(rslt$IFAULT != 0) {
	if(rslt$ifault == 4 && warn) {
		warning(paste("A near zero weight less than delta=0.00001\n",
                              "was replaced by delta.\n",sep=""))
	} else if(fatal) {
		stop(paste("Failed with ifault = ",rslt$ifault,".\n",sep=""))
        } else if(warn) {
		warning(paste("Algorithm gave ifault = ",rslt$ifault,".\n",sep=""))
	}
}
m <- matrix(rslt$G,nrow=nr,ncol=nc)
attr(m,"icycle") <- rslt$ICYCLE
attr(m,"ifault") <- rslt$IFAULT
m
}

unimode.sa <- function(y,lmode) {
# Note that the corresponding "x" vector is taken to be 1:n, so
# "lmode" makes most sense if it is one of 1, 1.5, 2, 2.5, ... n-1,
# n-0.5, n.  It can take other values but.  Results are based on
# size comparisons of y with lmode.
#
n  <- length(y)
x  <- 1:n
y1 <- y[x<lmode]
y2 <- y[x>lmode]
n1 <- length(y1)
n2 <- length(y2)
if(n1 <=1 ) return(pava(y,decreasing=TRUE))
if(n2 <=1 ) return(pava(y))
yh1 <- if(n1>0) pava(y1) else NULL
yh2 <- if(n2>0) pava(y2,decreasing=TRUE) else NULL
if(n1+n2==n) {
    yh  <- c(yh1,yh2)
} else {
    yh2 <- rev(yh2)
    o   <- order(c(yh1,yh2))
    r   <- rank(c(yh1,yh2))
    ys  <- c(c(yh1,yh2)[o],y[n1+1])
    yhs <- pava(ys)
    yyy <- (yhs[-n])[r]
    s1  <- seq(to=n1,length=n1)
    s2  <- seq(to=n-1,length=n2)
    yh <- c(yyy[s1], yhs[n], rev(yyy[s2]))
}
yh
}

ufit <- function(y,lmode=NULL,imode=NULL,x=NULL,w=NULL,lc=TRUE, rc=TRUE,
                 type=c("raw","stepfun","both")) {
#
# Function `ufit'.  Calculates the isotonic unimodal fit to a data
# sequence y, with mode at ``lmode''.  If lmode==NULL, then ufit() determines
# the optimal (least squares) location for the mode, and the fit
# for this optimum value.  The optimum mode may, by virtue of the
# nature of the procedure, be taken to be one of the points x_i, i =
# 1, ..., n.  NOTE that the optimum will occur at one of the
# midpoints (x_i + x_{i+1})/2, i = 1, ..., n-1 AND at one of the two
# adjacent points, i.e. either at x_i or at x_{i+1}.  If x is null, x
# is taken to be an equispaced sequence on [0,1].
#
type <- match.arg(type)

n <- length(y)
if(is.null(w)) w <- rep(1,n)
if(is.null(x)) x <- seq(0,1,length=n)
nargtype <- 1 + (!is.null(lmode)) + (!is.null(imode))*2
# 1 <--> neither is specified.
# 2 <--> lmode is specified, imode is not
# 3 <--> imode is specified, lmode is not
# 4 <--> both are specified

switch(EXPR=nargtype,
    {
# 1; neither lmode nor imode has been specified.
        imode <- -1 # Triggers search for optimum.
    },
    {
# 2; lmode is specified, imode is not specified.
        if(!lmode %in% x) {
            whinge <- paste0("If \"lmode\" is specified, it must be an entry\n",
                             "  of \"x\" which defaults to",
                             " seq(0,1,length=length(y)).\n")
            stop(whinge)
        }
        imode <- which(x==lmode)
    },
# 3; lmode is not specified, imode is specified.
    {
        if(!imode %in% 1:n) {
            whinge <- paste0("If \"imode\" is specified, it must be an integer\n",
                             "  between 1 and n = length(y).\n")
            stop(whinge)
        }
        lmode <- x[imode]
    },
# 4; both lmode and imode are specified --- error.
    {
        stop("Specify at most one of \"lmode\" and \"imode\".\n")
    }
)

rslt <- .Fortran(
		"ufit",
		y=as.double(y),
		w=as.double(w),
		imode=as.double(imode),
		ymdf=double(n),
		wmdf=double(n),
		mse=double(1),
		y1=double(n),
		w1=double(n),
		y2=double(n),
		w2=double(n),
		ind=integer(n),
		kt=integer(n),
		n=as.integer(n),
		PACKAGE="Iso"
		)
if(nargtype==1) {
    imode <- rslt$imode
    lmode <- x[imode]
}
ystar <- rslt$ymdf
if(type%in%c("stepfun","both")) {
	kind <- 1+which(diff(ystar)!=0)
	if(!(n%in%kind)) kind <- c(kind,n)
	y0   <- c(ystar[1],ystar[kind])
	h    <- stepfun(x[kind],y0)
}
i     <- floor(imode)
if(!lc) ystar[i]   <- NA
if( (!rc) & (i < n) ) ystar[i+1] <- NA
switch(type,raw=list(x=x,y=ystar,mode=lmode,mse=rslt$mse),
            stepfun=h,
            both=list(x=x,y=ystar,mode=lmode,mse=rslt$mse,h=h))
}

C Output from Public domain Ratfor, version 1.03
      subroutine ufit(y,w,imode,ymdf,wmdf,mse,y1,w1,y2,w2,ind,kt,n)
      implicit double precision(a-h,o-z)
      double precision imode, mse, imax
      dimension y(n), w(n), ymdf(n), wmdf(n),y1(n), w1(n), y2(n), w2(n),
     * ind(n), kt(n)
      if(imode .lt. 0)then
      m = n-1
      tau = 1.5d0
      imax = -1.d0
      ssemin = 1.d200
      do23002 i = 1,m 
      do23004 j = 1,n 
      ymdf(j) = y(j)
      wmdf(j) = w(j)
23004 continue
23005 continue
      call unimode(ymdf,wmdf,y1,w1,y2,w2,ind,kt,tau,n)
      sse = 0.d0
      do23006 j = 1,n 
      sse = sse + (ymdf(j)-y(j))**2
23006 continue
23007 continue
      if(sse .lt. ssemin)then
      ssemin = sse
      imax = tau
      endif
      tau = tau+1.d0
23002 continue
23003 continue
      k1 = int(imax-0.5d0)
      k2 = int(imax+0.5d0)
      else
      imax = imode
      endif
      do23010 j = 1,n 
      ymdf(j) = y(j)
      wmdf(j) = w(j)
23010 continue
23011 continue
      call unimode(ymdf,wmdf,y1,w1,y2,w2,ind,kt,imax,n)
      if(imode .lt. 0)then
      mse = ssemin/dble(n)
      if(ymdf(k1).ge.ymdf(k2))then
      imode=dble(k1)
      else
      imode=dble(k2)
      endif
      else
      sse = 0.d0
      do23016 j = 1,n 
      sse = sse + (ymdf(j)-y(j))**2
23016 continue
23017 continue
      mse = sse/dble(n)
      endif
      return
      end

pava <- function(y, w=NULL, decreasing=FALSE, long.out = FALSE, stepfun=FALSE)
{
#
# Function 'pava'.  To perform isotonic regression for a simple
# (increasing) linear ordering using the ``pool adjacent violators
# algorithm''.  If long.out = TRUE then the result returned consists
# of a list containing the fitted values, the final weights, and a set
# of indices `tr', made up of the smallest index in each level set,
# which thus keeps track of the level sets.  Otherwise only the fitted
# values are returned.
# 
	if(decreasing) y <- rev(y)
	n <- length(y)
	if(is.null(w))
		w <- rep(1, n)
	else if(decreasing) w <- rev(w)
	if(n == 1) {
		if(long.out) return(list(y=y,w=w,tr=1))
		else return(y)
	}

	rslt <- .Fortran(
			"pava",
			y=as.double(y),
			w=as.double(w),
			kt=integer(n),
			n=as.integer(n),
			PACKAGE="Iso"
			)
	y <- if(decreasing) rev(rslt$y) else rslt$y
	if(long.out | stepfun ) {
		tr <- rslt$kt
		if(decreasing) 
			tr <- unname(unlist(tapply(1:n,-rev(tr),
				function(x){rep(min(x),length(x))})))
	}
	if(long.out) {
		w <- if(decreasing) rev(rslt$w) else rslt$w
		lout <- list(y = y, w = w, tr = tr)
	}
	if(stepfun) {
		knots <- 1+which(diff(tr)!=0)
		y0    <- c(y[1],y[knots])
		h     <- stepfun(knots,y0)
	}
	ntype <- 1+sum(c(long.out,stepfun)*(1:2))
	switch(ntype,y,lout,h,c(lout,list(h=h)))
}

.onAttach <- function(lib, pkg) {
	ver <- read.dcf(file.path(lib, pkg, "DESCRIPTION"), "Version")
        packageStartupMessage(paste(pkg, ver))
        msg <- paste("\n     An \"infelicity\" in the function ufit() (whereby",
                     "\n     it was all too easy to conflate the location of",
                     "\n     the mode with its index in the entries of the",
                     "\n     \"x\" argument) has been corrected.  To this end,",
                     "\n     ufit() now has arguments \"lmode\" (the location",
                     "\n     of the mode), and \"imode\" (its index).  At most",
                     "\n     one of these arguments should be specified.  See",
                     "\n     the help for ufit().")
       packageStartupMessage(msg)
}

\documentclass[11pt]{article}

%\VignetteIndexEntry{Algorithm}

\usepackage{graphicx,float}
\usepackage{Sweave}
\usepackage{bm}
\usepackage{anysize}
\usepackage{wasysym}

%\marginsize{2cm}{2cm}{2cm}{2cm}

\newcommand{\pkg}[1]{\texttt{#1}}
\newcommand{\code}[1]{\texttt{#1}}
\newcommand{\R}{{\sf R}}
\newcommand{\Iso}{\pkg{Iso}}

\newcommand{\fol}{\mbox{$\prec \prec$}}
\newcommand{\iuc}{\mbox{${\cal I}^c$}}
\newcommand{\ilc}{\mbox{${\cal I}_c$}}
\newcommand{\qued}{\rule{2mm}{3.5mm}}
\parindent 0 cm

\begin{document}
\thispagestyle{empty}

<<echo=FALSE,results=hide,fig=FALSE>>=
options(SweaveHooks=list(fig=function() par(mar=c(1,1,1,1))))
@ 
\SweaveOpts{eps=TRUE}
\setkeys{Gin}{width=0.6\textwidth}

<<echo=FALSE,results=hide>>=
library(Iso)
sdate <- read.dcf(file = system.file("DESCRIPTION", package = "Iso"),
         fields = "Date")
sversion <- read.dcf(file = system.file("DESCRIPTION", package = "Iso"),
         fields = "Version")
options(useFancyQuotes=FALSE)
@ 

\title{The algorithm for calculating unimodal isotonic regression in \texttt{Iso}}
\author{Rolf Turner}
\date{For \Iso\ version \texttt{\Sexpr{sversion}}}
\maketitle

\begin{abstract}
The \Iso\ package provides an algorithm for applying isotonic
regression to data having an underlying unimodal structure.  This
algorithm consists essentially of ``divide and conquer'' approach to
this class of isotonic regression problems.  Repeated application of
the algorithm permits the estimation of the location of the maximum
of a data set assumed to have an underlying unimodal structure.
This estimation procedure is ``easily'' (for some value of the word
``easily'') shown to be consistent.  The performance
of the resulting procedure for locating a maximum has been assessed
through a simulation study described in one of the references.
This document supplies some of the background on the algorithm used
calculating unimodal isotonic regression and gives a theoretical
justification of why this algorithm works.
\end{abstract}

\tableofcontents
\newpage

\section{Introduction}
\label{S:intro}

Algorithms for implementing isotonic regression under orderings
other than the simple linear order are difficult to construct.
The best known of such algorithms is the Maximum Lower Sets algorithm
\cite[p. 24]{RobertsonEtAl1988}.  This algorithm is complicated
and hard to program.  It is also reputed to run rather slowly,
and indeed the number of operations required grows exponentially
in certain cases.

The motivation for developing an improved algorithm for performing
such regressions came in part from a data set being studied by
members of the Faculty of Forestry at the University of New Brunswick.
These data consisted of observations which had been made of the
``vigour'' of growth of five stands of black spruce.  The stands each
had different initial tree densities.  It was expected that vigour
would initially increase (as the trees increased in size) and then
level off and start to decrease as the growing trees encroached upon
each others' space and competed more strongly for resources such as
moisture, nutrients, and light.  It was further expected that the
position of the mode of the vigour observations would depend upon the
initial densities.

Plots of the data did not make it completely clear as to where the
leveling-off point or mode occurred; the Forestry researchers
requested a procedure for determining the location of this mode.  A
procedure which comes immediately to mind is to fit unimodal isotonic
regressions with mode at each of the possible locations in turn.  The
location yielding minimal error sum of squares is then chosen as the
location of the mode.  It is thus desirable to be able to perform a
large number of unimodal isotonic regressions quickly and
efficiently.

Formally the unimodal isotonic regression problem may be stated as
follows:  Suppose that $Y_{ij}$, $i=1, \ldots, p$, $j = 1, \ldots,
n_i$, are independent random variables such that $Y_{ij} = \mu_i +
E_{ij}$ for all $i$ and $j$, where the $E_{ij}$ have mean 0 and
variance $\sigma^2$.  Further suppose that the $\mu_i$ have a
{\em unimodal ordering}, i.e. that

\begin{equation}
\label{unimod1}
\mu_1 \leq \mu_2 \leq \ldots \leq \mu_{k_0} \geq \mu_{k_0 + 1}
\geq \ldots \geq \mu_p 
\end{equation}
for some $k_0$, $1 \leq k_0 \leq p$.  Of course if $k_0 = p$ then
we have the usual linear isotonic regression problem and if $k_0 =
1$ we the linear \emph{decreasing} order isotonic regression problem.

The problem is to estimate the values of $\mu_1, \ldots,
\mu_p$.  The (weighted) least squares estimates of the
$\mu_i$ are given by minimizing
\[
SS = \sum_i \sum_j (Y_{ij} - \hat{\mu}_i)^2 w_i
\]
subject to the constraint (\ref{unimod1}), where $w_1, \ldots, w_p$
are a (given) set of positive weights.  This problem may initially
be subdivided into three sub-problems involving only {\em linear}
orderings: (a) estimating $\mu_1, \ldots , \mu_{k-1}$; (b) estimating
$\mu_k$; and (c) estimating $\mu_{k+1}, \ldots , \mu_n$.  Sub-problem
(b) is of course trivial as it stands, and sub-problems (a) and (c)
can be solved by standard and well-known techniques.  The question is
how to combine the solutions of the three subproblems appropriately.

The answer is essentially to ``interleaf'' the estimates
resulting from solving sub-problems (a) and (c) in {\em
numerical} order, tack on $\hat{\mu}_k = \bar{Y}_{k.}$ at the upper
end, solve the corresponding isotonic regression with
respect to the resulting linear ordering, and then put the
estimates back in their original order.

In the next section we make this answer slightly more precise and
demonstrate that it is indeed correct.  The idea may be generalised
to other partial orderings and to other ``tree-like'' structures
as well as to unimodal ones but we will not elaborate on the details.

\section{Notation and Terminology, and the Main Result}
\label{mainres}
Let $k_0 \in S = \{1, \ldots, p\}$ be given (to avoid trivialitie
assume $1 < k_0 < p$ and let $\prec$ be the partial order on
given by $x \prec y$ if either $x \leq y \leq k_0$
or $x \geq y \geq k_0$.  If $x < k_0$ and $y > k_0$ or vice
versa then $x$ and $y$ are not comparable under $\prec$.

Recall that an isotonic function (with respect to the
partial order $\prec$) is a (real-valued) function $f$ such
that $x \prec y$ implies $f(x) \leq f(y)$.  If $g$ is an
arbitrary function on $S$, and $w$ is a non-negative
(weight) function on $S$, then the {\em isotonic
regression} of $g$, with respect to $\prec$ and $w$,
(denoted $g_*$) is that value of $\hat{g}$ which minimizes
\[
\sum_{s \in S} [g(s) - \hat{g}(s)]^2w(s)
\]
over all \emph{isotonic} functions $\hat{g}$.

Let $S_1$ and $S_2$ be two subsets of $S$.  We say that $S_2$ {\em
follows} $S_1$, (in symbols $S_1 \fol S_2$) if $x \prec y$ for every
$x$ in $S_1$ and every $y$ in $S_2$.

Let $S_1 = \{k \in S \mid k \neq k_0\}$ and $S_2 = \{k_0\}.$
Let $g_1$ be the restriction of $g$ to $S_1$, and let $g_{1*}$
be the isotonic regression of $g_1$r.  The weight function used to
form $g_{1*}$ is of course the restriction of the overall weight
function $w$ to $S_1$.

An elementary but important fact about isotonic regression
is that $g_*$ takes the form
\[ g_*(s) = c_i \mbox{ on } L_i, \; i = 1, \ldots, r
\]
where $L_1, \ldots, L_r$ form a disjoint and exhaustive
collection of subsets of $S$, and $c_1 < c_2 < \ldots <
c_r$.  Moreover $c_i$ is the weighted mean over $L_i$ of
the values of $g(s)$; i.e.
\[
c_i = \frac{\sum_{s \in L_i} w(s)g(s)}{\sum_{s \in L_i} w(s)}\;\;.
\]
(See \cite[p. 18, Theorem 1.3.5]{RobertsonEtAl1988}.)  We call the
sets $L_i$ the {\em level} sets and the values $c_i$ the {\em level}
values of the isotonic regression.

Let the level sets and level values for $g_{1*}$ be $L_1, \ldots,
L_{r}$ and $c_1 <  \ldots <  c_{r}$, and let $L_{r+1} =
\{k_0\}$ and let  $c_{r+1} = g(k_0)$.  Define a function $f$ on
$\{1, \ldots, r + 1 \}$, by $f(t) = c_t$ for $t = 1, \ldots r+1$,
and a weight function $u$ by
\[
u(t) = \sum_{x \in L_t} w(x) \;\;.
\]

{\bf Theorem 1:} Let $f$ and $u$ be as given above.  Let $f_*$ be the
isotonic regression of $f$ with respect to the usual order on $\{1,
\ldots, r+1 \}$ and the weight function $u$.  Then the isotonic
regression of $g$ with respect to $\prec$ and $w$ is given by
\[
g_*(s) = f_*(t) \mbox{ for } s \in L_t \;\;.
\]

\textbf{Remark:} Note that $S_1$ consists of the two disjoint sets
$\{1, \ldots, k-1 \}$ and $\{k+1, \ldots, n \}$ which are unrelated
with respect to $\prec$.  It is easy to see (and well-known; see,
e.g. \cite[p. 57]{RobertsonEtAl1988}) that an isotonic regression
on their union is simply the amalgamation of separate isotonic
regressions on each component.  That is $g_1*$ is obtained by doing
an ``ordinary'' isotonic regression of the restriction of $g$ to
$\{1, \ldots, k-1 \}$  and an isotonic regression of the restriction
of $g$ to $\{k+1, \ldots, p \}$  with respect to decreasing order
on this set.

To prove Theorem 1 we require the following definitions and a
couple of preliminary lemmas.

{\bf Definition:} For any constant $c$ we define
\[
\iuc = \{g | g \mbox{ is isotonic and~}
       g(s) \leq c \mbox{~for all~} s \in S \}
\]
and
\[
\ilc = \{g | g \mbox{ is isotonic and~} g(s) \geq c \mbox{~for all~} s \in S \} \;\;.
\]

Let $g_*(s)$ be the isotonic regression of $g$ and define
\[
g_{cu}(s) = \left \{ \begin{array}{cl}
g_*(s) & \mbox{ if } g_*(s) \leq c\\ c & \mbox{ if } g_*(s)
> c \;\;.\end{array} \right.
\]

{\bf Lemma 1:} The function $g_{cu}$ uniquely minimizes
\begin{equation} \sum_{s \in S} [g(s) - \hat{g}(s)]^2 w(s)
\label{eq:trunciso}
\end{equation}
subject to $\hat{g} \in \iuc$.

{\bf Proof:} For any $\hat{g}$ in $\iuc$,
\begin{eqnarray*}
\sum_{s \in S} [g(s) - g_{cu}(s)][g_{cu}(s) - \hat{g}(s)]w(s)
  & = & \sum_{s \in S} [g(s) - g_*(s)][g_{cu}(s) - g_*(s)]w(s)\\
  &   & + \sum_{s \in S} [g_*(s) - g_{cu}(s)]
                         [g_{cu}(s) - \hat{g}(s)]w(s)\\
  &   & + \sum_{s \in S} [g(s) - g_*(s)]
                         [g_*(s) - \hat{g}(s)]w(s)\\
  & = & \Sigma_1 + \Sigma_2 + \Sigma_3
\end{eqnarray*}

Now $ \Sigma_1 = 0 $ by \cite[Theorem 1.3.6,
p. 23]{RobertsonEtAl1988} since $g_{cu}(s) - g_*(s)$ is a function
of $g_*(s)$.  It is also true that $ \Sigma_3 \geq 0 $ since $g_*$
is the isotonic regression of $g$ (applying \cite[Theorem 1.3.1,
p. 15]{RobertsonEtAl1988}).  Finally
\begin{eqnarray*} \Sigma_2
& = & \sum_{g_*(s) > c} [g_*(s) - g_{cu}(s)][g_{cu}(s) -
		      \hat{g}(s)]w(s)\\
& = & \sum_{g_*(s) > c} [g_*(s) - c][c - \hat{g}(s)]w(s)
\geq 0 \;\;.
\end{eqnarray*}
Since $\iuc$ is a convex lattice we may apply the converse part
of \cite[Theorem 1.3.1, p. 15]{RobertsonEtAl1988}
and the result follows. \qued

Exactly analogous to Lemma 1 is

{\bf Lemma 2:}  The function
\[
g_{cl}(s) = \left \{ \begin{array}{cl} g_*(s) & \mbox{ if }
g_*(s) \geq c\\ c & \mbox{ if } g_*(s) < c \;\;.
\end{array} \right.
\]
uniquely minimizes (\ref{eq:trunciso}) for $\hat{g} \in \ilc$.

Lemma 3, given below, is an immediate consequence of Lemma 1 and 2:

{\bf Lemma 3:} Let $c_{k_1}, \ldots, c_{k_m}$ be a subset
of the level values of $g_*$, and let
\[
S' = S \setminus
\bigcup_{l=1}^m \{s | g_*(s) = c_{k_l} \} \neq \phi \;\;
\]
The isotonic regression of $g$ restricted to $S'$ is $g_*$ restricted
to $S'$.

We can now prove the main result:

{\bf Proof of Theorem 1:} Since $x \prec k_0$ for all $x \in S_1$
it is easy to see that there is a constant $c$ such that:
\begin{eqnarray*}
g_*(s) & < & c \mbox{~implies~} s \in S_1 {\rm and}\\
g_*(s) & > & c \mbox{~implies~} s = k_0 \;\;.
\end{eqnarray*}
The set $\{s | g(s) = c \}$ may contain elements from $S_1$ and
may contain $k_0$ as well.

For this $c$
\[
g_*(s) = \left \{ \begin{array}{cl}
         g_{cu}(s) & \mbox{ if } s \in S_1 \\
         g_{cl}(s) & \mbox{ if } s = k_0 \end{array} \right.
\]
otherwise we would contradict the definition of $g_*$.  Applying
Lemmas 1 and 2, it follows that
\[
g_{cu}(s) = \left \{ \begin{array}{cl}
            g_{1*}(s) & \mbox{ if } g_{1*}(s) < c \\
            c         & \mbox{ if } g_{1*}(s) \geq c \end{array} \right.
\]
for $s \in S_1$ and 
\[
g_{lu}(s) = \left \{ \begin{array}{cl}
            c         & \mbox{ if } g_{2*}(s) \leq c \\
            g_{2*}(s) & \mbox{ if } g_{2*}(s) > c \end{array} \right.
\]
for $s \in S_2$.  Therefore $g_*(s)$ is a function of $g_{1*}(s)$
on $S_1$.  In other words, $g_*(s)$ is constant on all of the
level sets $L_i$ of $g_{1*}$.  (Since $L_{r+1}$ consists of the
single point $k_0$, $g_*(s)$ is trivially constant on $L_{r+1}$.)
Let $g_*(s) = d_i$ on $L_i$ for $i = 1, \ldots, r+1$.
Now
\begin{eqnarray*}
\sum_S [g(s) - g_*(s)]^2w(s)
& = & \sum_{S_1} [g(s) - g_{1*}(s) + g_{1*}(s) - g_*(s)]^2w(s)\\
&   & + \sum_{S_2} [g(s) - g_{2*}(s) + g_{2*}(s)
      - g_*(s)]^2w(s)\\  & = & \sum_{S_1} [g(s) -g_{1*}(s)]^2w(s)
      + \sum_{S_2} [g(s) -g_{2*}(s)]^2w(s)\\
&   & + \sum_{S_1} [g_{1*}(s) -g_*(s)]^2w(s) + \sum_{S_2}
        [g_{2*}(s) -g_*(s)]^2w(s)\\
&   & +  2 \sum_{S_1} [g(s) - g_{1*}(s)]
                      [g_{1*}(s) - g_*(s)]w(s)\\
&   & + 2 \sum_{S_2} [g(s) - g_{2*}(s)][g_{2*}(s) - g_*(s)]w(s)
\end{eqnarray*}
% Check.  Pete had written Theorem 1.31.
The last two terms are zero by \cite[Theorem 1.3.1,
p. 15]{RobertsonEtAl1988}
since
$g_{1*}(s) - g_*(s)$ is a function of $g_{1*}(s)$, and
$g_{2*}(s) - g_*(s)$ is a function of $g_{2*}(s)$.  The
first two terms do not involve $g_*(s)$.  Hence $g_*(s)$
minimizes
\begin{equation}
\sum_{S_1} [g_{1*}(s) - g_*(s)]^2w(s) +
\sum_{S_2} [g_{2*}(s) - g_*(s)]^2w(s)
\label{eq:minim}
\end{equation}
and hence is the isotonic
regression of
\[
h(s) = \left \{
	\begin{array}{cl}
		g_{1*}(s) & \mbox{~if~} s \in S_1 \\
		g(s)      & \mbox{~if~} s = k_0
	\end{array} \right .
\]
It follows
readily that the values of $g_*(s)$ on $L_i$, i.e. $d_i$,
are in increasing order.  Since $g_*(s)$ minimizes
(\ref{eq:minim}), equal to
\[
\sum_{t=1}^{r} [ c_t - d_t ]^2 u(t)
\]
under the assumption that $g_*$ is isotonic, it follows that $d_1,
d_2, \ldots, d_r$ minimize this expression under simple linear
order on $1, 2, \ldots, r$, and hence $d_t = f_*(t)$ for all $t$.
\qued

\section{Estimating the Location of a Maximum}
\label{locmax}

\subsection{Consistency}

Let $Y_{ij}$ and $w_i$, $i=1, \ldots, p$, $j = 1, \ldots, n_i$, be as
described in Section \ref{S:intro}.  Suppose that the value of $k_0$ is
unknown and one wishes to estimate it in some rational manner.  The
(weighted) least squares estimate of $k_0$ may be determined by
assuming that $k_0 = k$ for each $k = 1, \ldots , p$ and finding the
(weighted) least squares estimates of the $\mu_i$, say
$\hat{\mu}_i(k)$ under this assumption.  Let $SS(k)$ be the
corresponding error sum of squares, i.e.
\[
SS(k) = \sum_i \sum_j (Y_{ij} - \hat{\mu}_i(k))^2 w_i
\]
The estimated value of $k_0$ is then that value of k which minimizes
$SS(k)$.

If we assume that the mode is a strict one, i.e. that
\begin{equation}
\label{unimod2}
\mu_1 \leq \mu_2 \leq \ldots \leq \mu_{k_0 - 1} < \mu_{k_0} > \mu_{k_0 + 1}
\geq \ldots \geq \mu_p \;,
\end{equation}
then it is not hard to demonstrate that this procedure yields
a consistent estimate of $k_0$.  We will not go into the details
here.

There are other ``obvious'' ways of estimating the location of
the maximum of a theoretical function underlying an observed data
set.  These include using the maximum of a fitted quadratic function
or the single knot of a fitted ``broken stick'' (piecewise linear)
model.  The performance of unimodal isotonic regression is compared
with these and other methods in \cite{turnerWollan1997}.

\subsection{Estimating a maximum in \Iso}

For a given data set, the \Iso\ function \texttt{ufit} (``unimodal
fit'') calculates the best (least squares) unimodal fit with
mode at a specified location given by the argument \texttt{lmode}
(``location of mode'').  If \texttt{lmode} is unspecified (i.e.
left with its default value of \texttt{NULL}) then \texttt{ufit}
searches over all possible modal locations and chooses that which
yields the minimal error sum of squares.

The search is feasible since there are a finite and limited number
of possibilities for the modal location.  If the largely notional
``predictor'' vector is \texttt{x} then the possible modal locations
are \texttt{x[i]}, with \texttt{i} running from \texttt{1} to
\texttt{n} $=$ \texttt{length(x)} and \texttt{(x[i] + x[i+1])/2}
with \texttt{i} running from \texttt{1} to \texttt{n-1}.  Note that
all possible modal locations that are strictly between \texttt{x[i]}
and \texttt{x[i+1]} are equivalent, so we restrict attention to
the midpoints.

The possibilities are even more limited than that, however.
Suppose that the optimal mode is at \texttt{x[i]} with \texttt{i}
$>$ \texttt{1}.  This says that the correponding isotoniation
of \texttt{y}, \texttt{y*} say, is increasing on \texttt{x[1]} to
\texttt{x[i]} and decreasing on \texttt{x[i]} to \texttt{x[n]}.  Let
the corresponding error sum of squares be SSE$_i$.  Now consider the
isotonisation of \texttt{y} with respect to the unimodal structure
with mode at \texttt{(x[i-1]+x[i])/2}, say \texttt{y**} and let the
corresponding error sum of squares be SSE$_{i-0.5}$.  Note that
\texttt{y*} satisfies the unimodal constraint that \texttt{y**}
has to satisfy and hence  SSE$_{i-0.5}$ $\leq$ SSE$_i$.  But SSE$_i$
is minimal over all possible modal locations, whence SSE$_i$ $\leq$
SSE$_{i-0.5}$ and  so SSE$_i$ is equal to SSE$_{i-0.5}$.

If the optimal mode is at \texttt{x[1]} then similar reasoning shows
that SSE$_1$ is equal to SSE$_{1.5}$.  Thus to find the optimal
mode we need only search over the ``half-points'' \texttt{(x[i] +
x[i+1])/2}, \texttt{i} running from \texttt{1} to \texttt{n-1}

If values of \texttt{y} are only meaningful at \texttt{x[1]},
\dots, \texttt{x[n]}, e.g. if the values of \texttt{y} are some
sort of annual amount or annual maximum, then the ``half-points''
only constitute a computational device and the optimal mode would
be said to occur at the ``whole-point'' \texttt{x[i]} having the
co-minimal value of SSE.

Note that if in searching over the ``half-points'' we find the
minimal sum of squares to be at \texttt{(x[i] + x[i+1])/2},
then either \texttt{x[i]} or \texttt{x[i+1]} will give rise to a
co-minimal value of SSE.  Letting \texttt{y*} be the isotonisation of
\texttt{y} corresponding to a mode at \texttt{(x[i] + x[i+1])/2}, we
see that if \texttt{y*[i]} $\geq$ \texttt{y*[i+1]} then \texttt{y*}
is also the isotonisation of \texttt{y} corresponding to a mode at
\texttt{x[i]}.  In this case \texttt{x[i]} will be an optimal modal
location.  Likewise if \texttt{y*[i]} $\leq$ \texttt{y*[i+1]} then
\texttt{y*} is also the isotonisation of \texttt{y} corresponding
to a mode at \texttt{x[i+1]}.  In this case \texttt{x[i+1]} will
be an optimal modal location.

If \texttt{y} consists of response values which can be observed
over a continuum of \texttt{x} values but which \emph{was} observed
only at \texttt{x[1]}, \dots, \texttt{x[n]}, then it is meaningful
for the response in question to have a mode at a ``half-point''.
In this case there is ambiguity --- there are always (at least)
two ``optimal'' modal locations.

\begin{figure}[H]
\centering
<<fig=TRUE,echo=FALSE,results=hide>>=
require(Iso)
OP <- par(mfrow=c(3,2),mar=c(4,4,3,1))
for(i in 2:6) {
   plot(ufit(vigour[,i],x=vigour[,1]),type="l",ylim=c(0,0.3),
        xlab="year",ylab="vigour",main=paste("stand",i-1),cex.main=1.5)
   points(vigour[,1],vigour[,i],pch="+",col="red")
}
par(OP)
@
\caption{Unimodal isotonisation of growth vigour for each of five stands
         of spruce trees over the years 1965 to 1987. The black line
         represents the optimal unimodal isotonic fit.
         The red $+$ symbols represent the raw data.
}
\label{fig:isoByStand}
\end{figure}

\subsection{Examples}

Consider the data set \texttt{vigour} which is included in the
\Iso package.  We can find the optimal location of maximum vigour
over the years 1965 to 1987 for each stand.  The code to fit the
isotonic models and plot the graphs of the fits follows.  The resulting
plots are shown in Figure~\ref{fig:isoByStand}. 

<<eval=FALSE>>=
par(mfrow=c(3,2),mar=c(4,4,3,1))
for(i in 2:6) {
   plot(ufit(vigour[,i],x=vigour[,1]),type="l",ylim=c(0,0.3),
        xlab="year",ylab="vigour",main=paste("stand",i-1),cex.main=1.5)
   points(vigour[,1],vigour[,i],pch="+",col="red")
}
@


Note that in this setting the ``vigour'' values are determined in
terms of an annual growth cycle whence they make sense only for
integrer values of ``year''.  Hence ``half=point'' modes are not
meaningful.

It may also be of interest to look for the optimal unimodal fit to
the mean, over stands.  A plot of the resulting fit is shown in
Figure~\ref{fig:isoMean}.

<<eval=FALSE>>=
   xm <- apply(vigour[,2:6],1,mean)
   par(mar=c(4,4,3,1))
   plot(ufit(xm,x=vigour[,1]),type="l",ylim=c(0,0.3),
        xlab="year",ylab="vigour",main="Mean over stands",cex.main=1.5)
   points(vigour[,1],xm,pch=22,col="red")
   for(i in 2:6) points(vigour[,1],vigour[,i],pch="+",col="blue")
@

\begin{figure}[H]
\centering
<<fig=TRUE,echo=FALSE,results=hide>>=
   xm <- apply(vigour[,2:6],1,mean)
   par(mar=c(4,4,3,1))
   plot(ufit(xm,x=vigour[,1]),type="l",ylim=c(0,0.3),
        xlab="year",ylab="vigour",main="Mean over stands",cex.main=1.5)
   points(vigour[,1],xm,pch=22,col="red")
   for(i in 2:6) points(vigour[,1],vigour[,i],pch="+",col="blue")
@
\caption{Unimodal isotonisation of the mean growth vigour over five stands
         of spruce trees for the years 1965 to 1987. The black line
         represents the optimal unimodal isotonic fit.  The blue
         $\Square$ symbols represent the raw means.  The red $+$
         symbols represent the data for all of the individual stands.
}
\label{fig:isoMean}
\end{figure}

{\bf Acknowledgement:}  The author would like to thank
Kirk Schmidt, a graduate student in the Department of
Forest Engineering, U.N.B., and his advisor Professor Ted
Needham, for drawing the problem on tree growth vigour to
his attention.
<<echo=FALSE,results=hide>>=
tools::compactPDF(".",gs_quality="ebook")
@

\newpage

\addcontentsline{toc}{section}{References}
\bibliographystyle{plain}
\bibliography{algorithm}
\end{document}

\name{vigour}
\alias{vigour}
\docType{data}
\title{
  vigour
}
\description{
Growth vigour of stands of spruce trees in New Brunswick, Canada.
}
\usage{data("vigour")}
\format{
  A data frame with 23 observations (rows).  The first column
  is the year of observation (1965 to 1987 inclusive).  The other
  five columns are observations on the vigour of growth of the
  given stand in each of the years.
}
\details{
  The stands each had different initial tree densities.  It was
  expected that vigour would initially increase (as the trees
  increased in size) and then level off and start to decrease as the
  growing trees encroached upon each others' space and competed more
  strongly for resources such as moisture, nutrients, and light.
  It was further expected that the position of the mode of the
  vigour observations would depend upon the initial densities.
}
  
\source{
  These data were collected and generously made available by Kirk
  Schmidt who was at the time of collecting the data a graduate
  student in the Department of Forest Engineering at the University
  of New Brunswick, Fredericton, New Brunswick, Canada.  The data
  were collected as part of his research for his Master's degree
  (supervised by Professor Ted Needham) at the University of New
  Brunswick.  See Schmidt (1993).
}
\references{
K. D. Schmidt  (1993). \emph{Development of a precommercial
thinning guide for black spruce}.  Thesis (M.Sc.F.), University of
New Brunswick, Faculty of Forestry.
}
\examples{
 matplot(vigour[,1],vigour[,2:6],
         main="Growth vigour of stands of New Brunswick spruce",
         xlab="year",ylab="vigour",type="b")
}
\keyword{datasets}

\name{biviso}
\Rdversion{1.1}
\alias{biviso}
\title{
   Bivariate isotonic regression.
}
\description{
   Bivariate isotonic regression with respect to simple (increasing)
   linear ordering on both variables.
}
\usage{
biviso(y, w = NULL, eps = NULL, eps2 = 1e-9, ncycle = 50000,
       fatal = TRUE, warn = TRUE)
}
\arguments{
  \item{y}{
  The matrix of observations to be isotonized.  It must of course
  have at least two rows and at least two columns.
}
  \item{w}{
  A matrix of weights, greater than or equal to zero, of the same
  dimension as \code{y}.  If left \code{NULL} then \code{w} is
  created as a matrix all of whose entries are equal to \code{1}.
}
  \item{eps}{
  Convergence criterion.  The algorithm is deemed to have converged
  if each entry of the output matrix, after the completion of the
  current iteration, does not differ by more than \code{eps} from
  the corresponding entry of the matrix after the completion of the
  previous iteration.  If this argument is not supplied it defaults
  to \code{sqrt(.Machine$double.eps)}.
}
  \item{eps2}{
  Criterion used to determine whether isotonicity is \dQuote{violated},
  whence whether (further) application of the \dQuote{pool adjacent violators}
  procedure is required.
}
  \item{ncycle}{
  The maximum number of cycles of the iteration procedure.  Must be
  at least 2 (otherwise an error is given).  If the procedure has not
  converged after \code{ncycle} iterations then an error is given.
  (See below.)
}
  \item{fatal}{
  Logical scalar.  Should the function stop if the subroutine
  returns an error code other than 0 or 4?  If \code{fatal} is
  \code{FALSE} then output is returned by the function even if
  there was a \dQuote{serious} fault.  One can set \code{fatal=FALSE}
  to inspect the values of the objective matrix at various interim
  stages prior to convergence.  See \bold{Examples}.
}
  \item{warn}{
  Logical scalar. Should a warning be produced if the subroutine
  returns a value of \code{ifault} equal to 4 (or to any other
  non-zero value when \code{fatal} has been set to \code{FALSE})?
}
}
\section{Error Messages}{
The subroutine comprising Algorithm AS 206 produces an error
code \code{ifault} with values from \code{0} to \code{6}
The meaning of these codes is as follows:
\itemize{
\item 0: No error.
\item 1: Convergence was not attained in \code{ncycle} cycles.
\item 2: At least one entry of \code{w} was negative.
\item 3: Either \code{nrow(y)} or \code{ncol(y)} was less than 2.
\item 4: A near-zero weight less than \code{delta=0.00001} was
          replaced by \code{delta}.
\item 5: Convergence was not attained \emph{and} a non-zero weight
         was replaced by \code{delta}.
\item 6: All entries of \code{w} were less than \code{delta}.
}

If \code{ifault==4} a warning is given.  All of the other non-zero
values of \code{ifault} result in an error being given.
}

\details{
  See the paper by Bril et al., (\emph{References}) and the references
  cited therein for details.
}
\value{
  A matrix of the same dimensions as \code{y} containing the
  corresponding isotonic values.  It has an attribute \code{icycle}
  equal to the number of cycles required to achieve convergence
  of the algorithm.
}
\references{
Bril, Gordon; Dykstra, Richard; Pillers Carolyn, and Robertson, Tim ;
Isotonic regression in two independent variables; Algorithm AS 206;
JRSSC (Applied Statistics), vol. 33, no. 3, pp. 352-357, 1984.
}
\author{Rolf Turner
\email{rolfturner@posteo.net}
}
\section{WARNING}{
This  function appears not to achieve exact isotonicity, at least
not quite.  For instance one can do:
\preformatted{
    set.seed(42)
    u  <- matrix(runif(400),20,20)
    iu <- biviso(u)
    any(apply(iu,2,is.unsorted))
}
and get \code{TRUE}.  It turns out that columns 13, 14, and 16 of
\code{iu} have exceptions to isotonicity.  E.g. six of the values
of \code{diff(iu[,13])} are less than zero.  However only one of
these is less than \code{sqrt(.Machine$double.eps)}, and then only
\dQuote{marginally} smaller.

So some of these negative values are \dQuote{numerically different}
from zero, but not by much.  The largest in magnitude in this
example, from column 16, is \code{-2.217624e-08} --- which is
probably not of \dQuote{practical importance}.

Note also that this example occurs in a very artificial context in
which there is no actual isotonic structure underlying the data.
}

\seealso{ \code{\link{pava}()} \code{\link{pava.sa}()} \code{\link{ufit}()}
}
\examples{
x <- 1:20
y <- 1:10
xy <- outer(x,y,function(a,b){a+b+0.5*a*b}) + rnorm(200)
ixy <- biviso(xy)

set.seed(42)
u <- matrix(runif(400),20,20)
v <- biviso(u)
progress <- list()
for(n in 1:9) progress[[n]] <- biviso(u,ncycle=50*n,fatal=FALSE,warn=FALSE)
}
\keyword{regression}
\keyword{nonlinear}

\name{pava}
\alias{pava}
\alias{pava.sa}
\title{
Linear order isotonic regression.
}
\description{
The ``pool adjacent violators algorithm'' (PAVA) is applied to
calculate the isotonic regression of a set of data, with respect
to the usual increasing (or decreasing) linear ordering on the indices.
}
\usage{
pava(y, w, decreasing=FALSE, long.out=FALSE, stepfun=FALSE)
pava.sa(y, w, decreasing=FALSE, long.out=FALSE, stepfun=FALSE)
}
\arguments{
\item{y}{
Vector of data whose isotonic regression is to be calculated.
}
\item{w}{
Optional vector of weights to be used for calculating a
weighted isotonic regression; if w is not given, all weights
are taken to equal 1.
}
\item{decreasing}{Logical scalar; should the isotonic regression
be calculated with respect to \emph{decreasing} (rather than
increasing) order?}
\item{long.out}{
Logical argument controlling the nature of the value returned.
}
\item{stepfun}{
Logical scalar; if \code{TRUE} a step function representation
of the isotonic regression is returned.
}
}
\value{
If long.out is TRUE then the result returned consists of a list whose
components are:

\item{y}{
the fitted values
}
\item{w}{
the final weights
}
\item{tr}{
a set of indices made up of the smallest index in each level set,
which thus "keeps track" of the level sets.
}
\item{h}{
a step function which represents the results of the isotonic
regression.  This component is present \emph{only if} 
\code{stepfun} is \code{TRUE}.
}

If \code{long.out} is \code{FALSE} and \code{stepfun} is \code{TRUE}
then only the step function is returned.

If \code{long.out} and \code{stepfun} are both \code{FALSE} then only
the vector of fitted values is returned.

}
\details{
The function \code{pava()} uses dynamically loading of a fortran
subroutine "pava" to effect the computations.  The function \code{pava.sa()}
("sa" for "stand-alone") does all of the computations in raw R.  Thus
\code{pava.sa()} could be considerably slower for large data sets.

The \code{x} values for the step function returned by these functions
(if \code{stepfun} is \code{TRUE}) are thought of as being 1, 2,
\dots, \code{n=length(y)}.  The knots of the step function are the
\code{x} values (indices) \emph{following} changes in the \code{y}
values (i.e. the starting indices of the level sets, except for the
first level set).  The \code{y} value corresponding to the first level
set is the ``left hand'' value of \code{y} or \code{yleft}.
The step function is formed using the default arguments of \code{stepfun()}.
In particular it is \emph{right} continuous.
}
\author{Rolf Turner
\email{rolfturner@posteo.net}
}
\references{
Robertson, T., Wright, F. T. and Dykstra, R.  L.  (1988).
Order Restricted Statistical Inference.  Wiley, New York.
}
\seealso{\code{\link{ufit}()} \code{\link{stepfun}()} \code{\link{biviso}()} }
\examples{
# Increasing order:
y <- (1:20) + rnorm(20)
ystar <- pava(y)
plot(y)
lines(ystar,type='s')
# Decreasing order:
z <- NULL
for(i in 4:8) {
	z <- c(z,rep(8-i+1,i)+0.05*(0:(i-1)))
}
zstar <- pava(z,decreasing=TRUE)
plot(z)
lines(zstar,type='s')
# Using the stepfunction:
zstar <- pava(z,decreasing=TRUE,stepfun=TRUE)
plot(z)
plot(zstar,add=TRUE,verticals=FALSE,pch=20,col.points="red")
}
\keyword{regression}
\keyword{nonlinear}

\name{ufit}
\alias{ufit}
\title{
Unimodal isotonic regression.
}
\description{
A "divide and conquer" algorithm is applied to calculate the isotonic
regression of a set of data, for a unimodal order.  If the mode of
the unimodal order is not specified, then the optimal (in terms of
minimizing the error sum of squares) unimodal fit is calculated.
}
\usage{
ufit(y, lmode=NULL, imode=NULL, x=NULL, w=NULL, lc=TRUE, rc=TRUE,
        type=c("raw","stepfun","both"))
}
\arguments{
\item{y}{
Vector of data whose isotonic regression is to be calculated.
}
\item{lmode}{
Numeric scalar specifiing the location of the mode.  It must be one
of the values of \code{x} (see below) otherwise an error is thrown.
}
\item{imode}{
Integer scalar specifying the index, amongst the values of \code{x}
(see below) of the location of the mode.  It must be one of the
indices from 1 to \code{n}, where \code{n} is the length of \code{y},
otherwise an error is thrown.

It is an error to specify both \code{lmode} and \code{imode}.

Note that if neither \code{lmode} nor \code{imode} is specified
then the function performs an exhaustive search among all possible
mode locations for the optimal (in terms of minimising the error
sum of squares) location.
}
\item{x}{
A somewhat notional vector of \eqn{x} values corresponding to the
data vector \code{y}; the value of the mode must be given, or will
be determined in terms of these \eqn{x} values.  Conceptually the
model is \code{y = m(x) + E}, where \code{m()} is a unimodal function
with mode at \code{lmode}, and where \code{E} is random "error".  If \code{x} is
not specified, it defaults to an equi-spaced sequence of length \code{n}
on [0,1] (where \code{n} is the length of \code{y}).
}
\item{w}{
Optional vector of weights to be used for calculating a weighted
isotonic regression; if \code{w} is not specified then all weights
are taken to equal 1.
}
\item{lc}{
Logical scalar; should the isotonization be left continuous?  If
\code{lc==FALSE} then the value of the isotonization just before the
mode is set to \code{NA}, which causes line plots to have a jump
discontinuity at (just to the left of) the mode.  The default is
\code{lc=TRUE}.}
\item{rc}{
Logical scalar; should the isotonization be right continuous?  If
\code{rc==FALSE} then the value of the isotonization just after the
mode is set to \code{NA}, which causes line plots to have a jump
discontinuity at (just to the right of) the mode.  The default is
\code{rc=TRUE}.}
\item{type}{String specifying the type of the output; see \bold{Value}.
May be abbreviated.}
}
\value{
If \code{type=="raw"} then the value is
a list with components:
\item{x}{
The argument \code{x} if this is specified, otherwise the default value.
}
\item{y}{
The fitted values.
}
\item{mode}{
The value of the location of the mode as determined by \code{lmode}
or \code{imode} if one of these was specified.  Otherwise it is
the value of the location of the mode which was found to minimize
the error sum of squares.
}
\item{mse}{ The mean squared error.}

If \code{type=="both"} then a component \code{h} which is the step function
representation of the isotonic regression is added to the foregoing list.

If \code{type=="stepfun"} then only the step function representation
\code{h} is returned.
}
\details{
This function dynamically loads fortran subroutines "pava", "ufit"
and "unimode" to do the actual work.
}
\author{Rolf Turner
\email{rolfturner@posteo.net}
}
\references{
Mureika, R. A., Turner, T. R. and Wollan, P. C.  (1992).
An algorithm for unimodal isotonic regression, with
application to locating a maximum.  University of New Brunswick
Department of Mathematics and Statistics Technical Report Number
92 -- 4.

Robertson, T., Wright, F. T. and Dykstra, R.  L.  (1988).
Order Restricted Statistical Inference.  Wiley, New York.

Shi, Ning-Zhong. (1988) A test of homogeneity for
umbrella alternatives and tables of the level probabilities.
Commun.  Statist. --- Theory Meth. vol. 17, pp. 657 -- 670.

Turner, T. R., and Wollan, P. C. (1997) Locating a maximum using
isotonic regression.  Computational Statistics and Data Analysis
vol. 25, pp. 305 -- 320.
}
\seealso{\code{\link{pava}()} \code{\link{biviso}()} }

\examples{
y <- c(0,1,2,3,3,2)
f1 <- ufit(y,lmode=0.4) # The third entry of the default
                        # value of x = c(0.0,0.2,0.4,0.6,0.8,1.0).
f2 <- ufit(y,imode=3)   # Identical to f1.
f3 <- ufit(y,lmode=3,x=1:6)   # Effectively the same as f1 and f2.
                              # But is different  in appearance.
f4 <- ufit(y,imode=3,x=1:6)   # Identical to f3.

\dontrun{
    ufit(y,lmode=3)     # Throws an error.
    ufit(y,imode=7)     # Throws an error.
}

x <- c(0.00,0.34,0.67,1.00,1.34,1.67,2.00,2.50,3.00,3.50,4.00,4.50,
       5.00,5.50,6.00,8.00,12.00,16.00,24.00)
y <- c(0.0,61.9,183.3,173.7,250.6,238.1,292.6,293.8,268.0,285.9,258.8,
       297.4,217.3,226.4,170.1,74.2,59.8,4.1,6.1)
z <- ufit(y,x=x,type="b")
plot(x,y)
lines(z,col="red")
plot(z$h,do.points=FALSE,col.hor="blue",col.vert="blue",add=TRUE)
abline(v=z$mode,col="green",lty=2)
}
\keyword{regression}
\keyword{nonlinear}

\name{Iso-internal}
\alias{unimode.sa}
\title{Internal Iso functions}
\description{
  Internal Iso functions.
}
\usage{
unimode.sa(y,lmode)
}
\details{
  This functions is for debugging and pedagogical use; it is not
  meant to be called by the average user.
}
\keyword{internal}
